function CleanUI_InitRecount()
    if (not CleanUI_RecountInstalled()) then
    	return;
    end    
    
    CleanUI_RemoveTextures(Recount_MainWindow); 
    CleanUI_SetBackdrop(Recount_MainWindow, true, false, nil, nil, -8, -2, -2, 2);
    CleanUI_RemoveTextures(Recount_GraphWindow); 
    CleanUI_SetBackdrop(Recount_GraphWindow, true, false, nil, nil, -8, -2, -2, 2);
    CleanUI_RemoveTextures(Recount_DetailWindow); 
    CleanUI_SetBackdrop(Recount_DetailWindow, true, false, nil, nil, -8, -2, -2, 2);
    
    Recount_MainWindow:SetClampedToScreen(true);
end

function CleanUI_ToggleRecount()
	if (Recount.MainWindow:IsShown()) then
		Recount.MainWindow:Hide();
	else
		Recount.MainWindow:Show();
		Recount:RefreshMainWindow();
	end
end

function CleanUI_RecountInstalled()
    if (Recount_MainWindow) then
    	return true;
    end   
    
    return false;
end