ZoneNames = {};

selectedWayPoint = nil;

function LoadZones(...)
   for i=1, arg.n, 1 do
      ZoneNames[i] = arg[i];
   end
end

CUI_MAP_INFO = {};

CUI_MAP_INFO[0] = {name="elwynn", min=1, max=10, faction="a", left=45, top=75};
CUI_MAP_INFO[1] = {name="westfall", min=10, max=15, faction="a", left=41, top=82};
CUI_MAP_INFO[2] = {name="rotkamm", min=15, max=20, faction="", left=52, top=76};
CUI_MAP_INFO[3] = {name="daemm", min=20, max=25, faction="", left=46, top=81};
CUI_MAP_INFO[4] = {name="schling1", min=25, max=30, faction="", left=47, top=86};
CUI_MAP_INFO[5] = {name="schling2", min=30, max=35, faction="", left=44, top=92};
CUI_MAP_INFO[6] = {name="suempfe", min=52, max=54, faction="", left=53, top=80};
CUI_MAP_INFO[7] = {name="verwuest", min=54, max=58, faction="", left=52, top=85};
CUI_MAP_INFO[8] = {name="brenn", min=50, max=52, faction="", left=51, top=71};
CUI_MAP_INFO[9] = {name="seng", min=48, max=50, faction="", left=47, top=66};
CUI_MAP_INFO[10] = {name="oedl", min=45, max=48, faction="", left=53, top=67};
CUI_MAP_INFO[11] = {name="vashi", min=80, max=82, faction="", left=31, top=63};
CUI_MAP_INFO[12] = {name="dun", min=1, max=10, faction="a", left=44, top=61};
CUI_MAP_INFO[13] = {name="loch", min=10, max=20, faction="a", left=53, top=61};
CUI_MAP_INFO[14] = {name="sumpfl", min=20, max=25, faction="", left=49, top=53};
CUI_MAP_INFO[15] = {name="schatten", min=84, max=85, faction="", left=55, top=55};
CUI_MAP_INFO[16] = {name="arathi", min=25, max=30, faction="", left=51, top=46};
CUI_MAP_INFO[17] = {name="hinter", min=30, max=35, faction="", left=52, top=40};
CUI_MAP_INFO[18] = {name="vorgeb", min=20, max=25, faction="", left=46, top=43};
CUI_MAP_INFO[19] = {name="giln", min=1, max=12, faction="a", left=40, top=47};
CUI_MAP_INFO[20] = {name="silber", min=10, max=20, faction="h", left=41, top=41};
CUI_MAP_INFO[21] = {name="tiris", min=1, max=10, faction="h", left=44, top=33};
CUI_MAP_INFO[22] = {name="westl", min=35, max=40, faction="", left=49, top=33};
CUI_MAP_INFO[23] = {name="oestl", min=40, max=45, faction="", left=54, top=32};
CUI_MAP_INFO[24] = {name="immer", min=1, max=10, faction="h", left=55, top=17};
CUI_MAP_INFO[25] = {name="geister", min=10, max=20, faction="h", left=55, top=24};
CUI_MAP_INFO[26] = {name="quelda", min=70, faction="pvp", left=56, top=5};
CUI_MAP_INFO[27] = {name="tolbarad", min=85, faction="pvp", left=35, top=49};
CUI_MAP_INFO[28] = {name="maelst1", info="Maelstrom", min=82, max=83, faction="", left=6, top=41};

CUI_MAP_INFO[29] = {name="maelst2", info="Maelstrom", min=82, max=83, faction="", left=86, top=41};
CUI_MAP_INFO[30] = {name="uldum", min=83, max=84, faction="", left=47, top=91};
CUI_MAP_INFO[31] = {name="tanaris", min=45, max=50, faction="", left=55, top=86};
CUI_MAP_INFO[32] = {name="ungoro", min=50, max=55, faction="", left=50, top=81};
CUI_MAP_INFO[33] = {name="silithus", min=55, max=60, faction="", left=42, top=82};
CUI_MAP_INFO[34] = {name="feralas", min=35, max=40, faction="", left=43, top=70};
CUI_MAP_INFO[35] = {name="tausend", min=40, max=45, faction="", left=51, top=74};
CUI_MAP_INFO[36] = {name="morast", min=35, max=40, faction="", left=56, top=70};
CUI_MAP_INFO[37] = {name="suedlbrach", min=30, max=35, faction="", left=52, top=60};
CUI_MAP_INFO[38] = {name="mulgore", min=1, max=10, faction="h", left=47, top=62};
CUI_MAP_INFO[39] = {name="desolace", min=30, max=35, faction="", left=41, top=58};
CUI_MAP_INFO[40] = {name="steinkral", min=25, max=30, faction="", left=43, top=47};
CUI_MAP_INFO[41] = {name="noerdlbrach", min=10, max=20, faction="h", left=52, top=50};
CUI_MAP_INFO[42] = {name="durotar", min=1, max=10, faction="h", left=58, top=51};
CUI_MAP_INFO[43] = {name="azshara", min=10, max=20, faction="h", left=60, top=40};
CUI_MAP_INFO[44] = {name="eschental", min=20, max=25, faction="", left=50, top=42};
CUI_MAP_INFO[45] = {name="teufelswald", min=45, max=50, faction="", left=49, top=27};
CUI_MAP_INFO[46] = {name="hyal", min=80, max=82, faction="", left=53, top=33};
CUI_MAP_INFO[47] = {name="winterq", min=50, max=55, faction="", left=57, top=25};
CUI_MAP_INFO[48] = {name="dunkelk", min=10, max=20, faction="a", left=47, top=23};
CUI_MAP_INFO[49] = {name="teldra", min=1, max=10, faction="a", left=42, top=11};
CUI_MAP_INFO[50] = {name="blutmyt", min=10, max=20, faction="a", left=29, top=19};
CUI_MAP_INFO[51] = {name="azurm", min=1, max=10, faction="a", left=32, top=28};

CUI_MAP_INFO[52] = {name="hoellenf", min=58, max=63, faction="", left=54, top=52};
CUI_MAP_INFO[53] = {name="zangar", min=60, max=64, faction="", left=33, top=48};
CUI_MAP_INFO[54] = {name="terokkar", min=62, max=65, faction="", left=46, top=75};
CUI_MAP_INFO[55] = {name="nagrand", min=64, max=67, faction="", left=30, top=65};
CUI_MAP_INFO[56] = {name="schergrat", min=65, max=68, faction="", left=38, top=30};
CUI_MAP_INFO[57] = {name="nethersturm", min=67, max=70, faction="", left=57, top=19};
CUI_MAP_INFO[58] = {name="schattenmond", min=67, max=70, faction="", left=64, top=80};

CUI_MAP_INFO[59] = {name="heulenderf", min=68, max=72, faction="", left=77, top=75};
CUI_MAP_INFO[60] = {name="borean", min=68, max=72, faction="", left=23, top=61};
CUI_MAP_INFO[61] = {name="drachenoede", min=71, max=74, faction="", left=48, top=55};
CUI_MAP_INFO[62] = {name="grizzly", min=73, max=75, faction="", left=73, top=54};
CUI_MAP_INFO[63] = {name="zuldrak", min=74, max=77, faction="", left=67, top=42};
CUI_MAP_INFO[64] = {name="sholazar", min=76, max=78, faction="", left=23, top=41};
CUI_MAP_INFO[65] = {name="sturmgipfel", min=77, max=80, faction="", left=59, top=27};
CUI_MAP_INFO[66] = {name="eiskrone", min=77, max=80, faction="", left=38, top=28};
CUI_MAP_INFO[67] = {name="kristalls", min=77, max=80, faction="", left=50, top=41};
CUI_MAP_INFO[68] = {name="tausendw", min=77, max=80, faction="pvp", left=35, top=48};

CUI_MAP_INFO[69] = {name="jade", min=85, max=86, faction="", left=65, top=53};
CUI_MAP_INFO[70] = {name="fourwinds", min=86, max=87, faction="", left=48, top=66};
CUI_MAP_INFO[71] = {name="krasang", min=86, max=87, faction="", left=50, top=78};
CUI_MAP_INFO[72] = {name="kunlai", min=87, max=88, faction="", left=44, top=38};
CUI_MAP_INFO[73] = {name="townlong", min=88, max=89, faction="", left=30, top=42};
CUI_MAP_INFO[74] = {name="dread", min=89, max=90, faction="", left=34, top=63};
CUI_MAP_INFO[75] = {name="vale", min=90, max=90, faction="", left=47, top=55};
        
-- 13 = Kalimdor
-- 14 = Azeroth
-- 466 = Outlands
-- 485 = Northrend
-- 862 = Pandaria

CUI_MAP_RANGE = {};
CUI_MAP_RANGE[14] = {min = 0, max = 28};
CUI_MAP_RANGE[13] = {min = 29, max = 51};
CUI_MAP_RANGE[466] = {min = 52, max = 58};
CUI_MAP_RANGE[485] = {min= 59, max = 68};
CUI_MAP_RANGE[862] = {min= 69, max = 75};

CUI_MAP_STATIONS = { };
CUI_MAP_STATIONS["STORMWIND"] = {left=79.8, top=64.0, faction="a"};
CUI_MAP_STATIONS["IRONFORGE"] = {left=80.7, top=53.6, faction="a"};
CUI_MAP_STATIONS["MENETHIL"] = {left=83.4, top=50.1, faction="a"};
CUI_MAP_STATIONS["VASHJ'IR"] = {left=75.2, top=52.6, faction="n"};
CUI_MAP_STATIONS["UNDERCITY"] = {left=80.5, top=38.4, faction="h"};
CUI_MAP_STATIONS["GROM'GOL"] = {left=80.6, top=71.7, faction="h"};
CUI_MAP_STATIONS["BOOTY BAY"] = {left=80.8, top=75.7, faction="n"};
CUI_MAP_STATIONS["VENGEANCE LANDING"] = {left=63.4, top=24.6, faction="h"};
CUI_MAP_STATIONS["VALGARDE"] = {left=61.2, top=28.5, faction="a"};
CUI_MAP_STATIONS["KAMAGUA"] = {left=58.2, top=28.0, faction="n"};
CUI_MAP_STATIONS["MOA'KI HARBOR"] = {left=51.7, top=22.6, faction="n"};
CUI_MAP_STATIONS["UNU'PE"] = {left=45.8, top=22.7, faction="n"};
CUI_MAP_STATIONS["VALIANCE KEEP"] = {left=43.2, top=24.2, faction="a"};
CUI_MAP_STATIONS["WARSONG HOLD"] = {left=41.6, top=23.0, faction="h"};
CUI_MAP_STATIONS["RUT'THERAN VILLAGE"] = {left=14.6, top=27.5, faction="a"};
CUI_MAP_STATIONS["VALAAR'S BERTH"] = {left=6.5, top=35.2, faction="a"};
CUI_MAP_STATIONS["ORGRIMMAR"] = {left=24.3, top=46.2, faction="h"};
CUI_MAP_STATIONS["THUNDER BLUFF"] = {left=17.4, top=51.0, faction="h"};
CUI_MAP_STATIONS["RATCHET"] = {left=23.5, top=52.6, faction="n"};
CUI_MAP_STATIONS["THERAMORE ISLE"] = {left=24.9, top=59.5, faction="a"};

CUI_MAP_ROUTES = {};
CUI_MAP_ROUTES[0] = {start="VALGARDE", ende="MENETHIL", faction="a"};
CUI_MAP_ROUTES[1] = {start="VALIANCE KEEP", ende="STORMWIND", faction="a"};
CUI_MAP_ROUTES[2] = {start="VASHJ'IR", ende="STORMWIND", faction="a"};
CUI_MAP_ROUTES[3] = {start="RUT'THERAN VILLAGE", ende="STORMWIND", faction="a"};
CUI_MAP_ROUTES[4] = {start="THERAMORE ISLE", ende="MENETHIL", faction="a"};
CUI_MAP_ROUTES[5] = {start="VALAAR'S BERTH", ende="RUT'THERAN VILLAGE", faction="a"};
CUI_MAP_ROUTES[6] = {start="STORMWIND", ende="IRONFORGE", faction="a"};

CUI_MAP_ROUTES[7] = {start="VENGEANCE LANDING", ende="UNDERCITY", faction="h"};
CUI_MAP_ROUTES[8] = {start="UNDERCITY", ende="GROM'GOL", faction="h"};
CUI_MAP_ROUTES[9] = {start="UNDERCITY", ende="ORGRIMMAR", faction="h"};
CUI_MAP_ROUTES[10] = {start="GROM'GOL", ende="ORGRIMMAR", faction="h"};
CUI_MAP_ROUTES[11] = {start="ORGRIMMAR", ende="VASHJ'IR", faction="h"};
CUI_MAP_ROUTES[12] = {start="ORGRIMMAR", ende="THUNDER BLUFF", faction="h"};
CUI_MAP_ROUTES[13] = {start="ORGRIMMAR", ende="WARSONG HOLD", faction="h"};

CUI_MAP_ROUTES[14] = {start="RATCHET", ende="BOOTY BAY", faction="n"};
CUI_MAP_ROUTES[15] = {start="UNU'PE", ende="MOA'KI HARBOR", faction="n"};
CUI_MAP_ROUTES[16] = {start="MOA'KI HARBOR", ende="KAMAGUA", faction="n"};

local loaded = false;

function CleanUI_InitMap()

    local infoframe = _G["CleanUIMapFrame"];
    infoframe:ClearAllPoints(); 
    infoframe:SetAllPoints(WorldMapDetailFrame);
    
    local waypoints = _G["CleanUIMapWayPointFrame"];
    waypoints:ClearAllPoints(); 
    waypoints:SetAllPoints(WorldMapDetailFrame);
    
    local playerLevel = UnitLevel("player");
        
	for ii=0, #(CUI_MAP_INFO), 1 do	
	    local fontstring = _G["CUI_MI_"..CUI_MAP_INFO[ii].name];
	    
	    if (not fontstring) then
	        fontstring = infoframe:CreateFontString("CUI_MI_"..CUI_MAP_INFO[ii].name, "ARTWORK");
	    end
	    
        fontstring:SetFontObject("GameFontNormalSmall");
        
        local min = CUI_MAP_INFO[ii].min;
        local max = CUI_MAP_INFO[ii].max or min;
        local info = CUI_MAP_INFO[ii].info;
        
        local text = ""..min;
        
        if (min < max) then
            text = text.."-"..max;
        end
        
        if (info) then
            text = info.." "..text;
        end
        
        local color = "ffffff";
        
        if (CUI_MAP_INFO[ii].faction == "a") then
            color = "4444dd";
        elseif (CUI_MAP_INFO[ii].faction == "h") then
            color = "dd4444";
        elseif (CUI_MAP_INFO[ii].faction == "pvp") then
            color = "aa44aa";
        end
        
        text = "|cff"..color..text.."|r";
        
        -- font size and alpha
        if (playerLevel > max) then
            fontstring:SetFontObject("GameFontNormalSmall");
            fontstring:SetAlpha(0.5);
        elseif (playerLevel > min and playerLevel < max) then
            fontstring:SetFontObject("GameFontNormal");
            fontstring:SetAlpha(1.0);
        else
            fontstring:SetFontObject("GameFontNormalSmall");
            fontstring:SetAlpha(1.0);
        end  
        
        -- faction icon
        if (CUI_MAP_INFO[ii].faction == "a") then
            text = "|TInterface/WorldStateFrame/AllianceIcon:20|t"..text;
        elseif (CUI_MAP_INFO[ii].faction == "h") then
            text = "|TInterface/WorldStateFrame/HordeIcon:20|t"..text;
        elseif (CUI_MAP_INFO[ii].faction == "pvp") then
            text = "|TInterface/GossipFrame/BattleMasterGossipIcon:20|t"..text;
        end
        
        -- level icon
        if (playerLevel < min - 5) then
            text = "|TInterface/TargetingFrame/UI-TargetingFrame-Skull:20|t"..text;
        elseif (playerLevel > min - 1 and playerLevel < max + 1) then
            text = "|TInterface/OptionsFrame/UI-OptionsFrame-NewFeatureIcon:16|t"..text;
        end
        
        fontstring:SetText(text);
        
        local framewidth = infoframe:GetWidth();
        local frameheight = infoframe:GetHeight();
        
        local x = CUI_MAP_INFO[ii].left / 100 * framewidth;
        local y = CUI_MAP_INFO[ii].top / 100 * frameheight * -1;
        
        fontstring:ClearAllPoints(); 
        fontstring:SetPoint("CENTER", infoframe, "TOPLEFT", x, y);
    end
    
    -- Header
    if (not _G["CUI_MI_HEADER"]) then
        local header = infoframe:CreateFontString("CUI_MI_HEADER", "ARTWORK");
        header:SetFontObject("GameFontNormalSmall");
        header:SetText("|cffffffff"..BATTLEFIELD_LEVEL.."|r");
        header:ClearAllPoints(); 
        header:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -30);
    end
    
    -- Allianz
    if (not _G["CUI_MI_ALLIANCE"]) then
        local horde = infoframe:CreateFontString("CUI_MI_ALLIANCE", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|TInterface/WorldStateFrame/AllianceIcon:20|t".."|cff4444dd"..FACTION_ALLIANCE.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -50);
    end
    
    if (not _G["CUI_MI_HORDE"]) then
    -- Horde
        local horde = infoframe:CreateFontString("CUI_MI_HORDE", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|TInterface/WorldStateFrame/HordeIcon:20|t".."|cffdd4444"..FACTION_HORDE.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -66);
    end
    
    -- Passend
    if (not _G["CUI_MI_BEST"]) then
        local all = infoframe:CreateFontString("CUI_MI_BEST", "ARTWORK");
        all:SetFontObject("GameFontNormalSmall");
        all:SetText( "|TInterface/OptionsFrame/UI-OptionsFrame-NewFeatureIcon:16|t".."|cffffffff"..CURRENT_QUESTS.."|r");
        all:ClearAllPoints(); 
        all:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -82);
    end
    
    -- PvP
    if (not _G["CUI_MI_PVP"]) then
        local horde = infoframe:CreateFontString("CUI_MI_PVP", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|TInterface/GossipFrame/BattleMasterGossipIcon:20|t".."|cffaa44aa"..PVP.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -98);
    end
    
    -- PvP
    if (not _G["CUI_MI_DIFFICULT"]) then
        local horde = infoframe:CreateFontString("CUI_MI_DIFFICULT", "ARTWORK");
        horde:SetFontObject("GameFontNormalSmall");
        horde:SetText("|TInterface/TargetingFrame/UI-TargetingFrame-Skull:20|t".."|cffffffff"..TRACKER_SORT_DIFFICULTY_HIGH.."|r");
        horde:ClearAllPoints(); 
        horde:SetPoint("TOPLEFT", infoframe, "TOPRIGHT", -125, -114);
    end
    
    local frame = CreateFrame("Frame", "CUI_MapUpdateFrame");
    frame:HookScript("OnUpdate", CleanUI_WorldMap_OnUpdate);
    
    CleanUI_MapHookEvents();
    CleanUI_RegisterMapEvents();
    CleanUI_CleanWorldMapUI();

    loaded = true;
end
    
function CleanUI_RegisterMapEvents()         
    local frame = CreateFrame("Frame");
    
    frame:RegisterEvent("WORLD_MAP_UPDATE");  
    frame:RegisterEvent("PLAYER_LEVEL_UP");  
    frame:RegisterEvent("CHAT_MSG_ADDON");  
    
    frame:HookScript("OnEvent", CleanUI_MapOnEvent); 
end

function CleanUI_MapOnEvent(self, event, ...)
    if (event == "WORLD_MAP_UPDATE") then
        local miniWorldMap = GetCVar("miniWorldMap");   
        CleanUI_UpdateMap(miniWorldMap);
    end
    if (event == "PLAYER_LEVEL_UP") then
        CleanUI_StartDelay(CUI_START_DELAY, CleanUI_InitMap);
    end
    if (event == "CHAT_MSG_ADDON") then
        local prefix, message, type, sender = ...;
        CleanUI_ReceiveWayPoint(prefix, message, type, sender);
    end
end

function CleanUI_MapHookEvents()
    hooksecurefunc("ProcessMapClick", CleanUI_ProcessMapClick); 
    hooksecurefunc("WorldMap_ToggleSizeUp", CleanUI_WorldMap_ToggleSizeUp); 
    hooksecurefunc("WorldMap_ToggleSizeDown", CleanUI_WorldMap_ToggleSizeDown); 
    hooksecurefunc("WorldMapFrame_DisplayQuests", CleanUI_WorldMapFrame_DisplayQuests); 
    hooksecurefunc("WorldMapShowDropDown_Initialize", CleanUI_WorldMapShowDropDown_Initialize); 
end
    
function CleanUI_CleanWorldMapUI()         
    -- CleanUI_RemoveTextures(WorldMapFrame);  
    -- CleanUI_SetBackdrop(WorldMapFrame); 
    -- CleanUI_ChangeCloseButton(WorldMapFrame, nil, WorldMapFrameCloseButton); 
end
    
function CleanUI_WorldMap_ToggleSizeUp() 
    CleanUI_UpdateMap("0");
    -- CleanUI_RemoveTextures(WorldMapFrame);
end
    
function CleanUI_WorldMap_ToggleSizeDown()  
    CleanUI_UpdateMap("1");
    -- CleanUI_RemoveTextures(WorldMapFrame); 
end

function CleanUI_WorldMapFrame_DisplayQuests(selectQuestId)
    local miniWorldMap = GetCVar("miniWorldMap");   
    CleanUI_UpdateMap(miniWorldMap);
    
    if (miniWorldMap == "0") then
        -- full screen
    	WorldMapTrackQuest:Show();
    else
    	WorldMapTrackQuest:Hide();  
    end
end
    
function CleanUI_WorldMap_OnUpdate(self, elapsed)
    local player_x, player_y = CleanUI_GetPlayerMapPosition();
    local cursor_x, cursor_y = CleanUI_GetCursorPosition();
    
    local output = "";
    
    if (cursor_x == nil or cursor_y == nil) then
        output = CUI_PLAYER..": "..player_x.."|cffffffff/|r"..player_y;
    else
        output = CUI_PLAYER..": "..player_x.."|cffffffff/|r"..player_y.." -- "..CUI_CURSOR..": "..cursor_x.."|cffffffff/|r"..cursor_y;
    end

    CleanUIWorldMapCoords:SetText(output);
end

function CleanUI_GetPlayerMapPosition()
	local x, y = GetPlayerMapPosition("player");
	
	x = x * 100;
	y = y * 100;
	
	return "|cffffffff"..string.format("%.1f", x).."|r", "|cffffffff"..string.format("%.1f", y).."|r";
end

function CleanUI_GetCursorPosition()
	
    local scale = WorldMapDetailFrame:GetEffectiveScale();
    local width = WorldMapDetailFrame:GetWidth();
    local height = WorldMapDetailFrame:GetHeight();
    local centerX, centerY = WorldMapDetailFrame:GetCenter();
    
    local x, y = GetCursorPosition();
    
    local adjustedX = (x / scale - (centerX - (width/2))) / width;
    local adjustedY = (centerY + (height/2) - y / scale) / height;	
	
	adjustedX = adjustedX * 100;
	adjustedY = adjustedY * 100;
	
	if (adjustedX > 100 or adjustedY > 100) then
	    return nil, nil, 0, 0;
	end

	return "|cffffffff"..string.format("%.1f", adjustedX).."|r", "|cffffffff"..string.format("%.1f", adjustedY).."|r", adjustedX, adjustedY;
end

function CleanUI_WorldMapShowDropDown_Initialize()
	local info = UIDropDownMenu_CreateInfo();
	
	-- map level
	local toggleMapLevel = (CleanUIData.MAP_SHOWQUESTLEVEL == 1);
	
	info.text = CONFIG_TOGGLEMAPLEVEL;
	info.func = CleanUI_ToggleMapLevel;
	info.checked = toggleMapLevel;
	info.isNotRadio = true;
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);
	
	-- map level
	local toggleMapRoutes = (CleanUIData.MAP_SHOWSHIPROUTES == 1);
	
	info.text = CONFIG_TOGGLEMAPROUTES;
	info.func = CleanUI_ToggleMapRoutes;
	info.checked = toggleMapRoutes;
	info.isNotRadio = true;
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);
	
	-- map level
	local toggleWayPoints = (CleanUIData.MAP_SHOWWAYPOINTS == 1);
	
	info.text = CONFIG_TOGGLEWAYPOINTS;
	info.func = CleanUI_ToggleWayPoints;
	info.checked = toggleWayPoints;
	info.isNotRadio = true;
	info.keepShownOnClick = 1;
	UIDropDownMenu_AddButton(info);
end

function CleanUI_UpdateMap(miniWorldMap) 

    if (not loaded) then
        return;
    end
    
    if (not WorldMapFrame:IsVisible()) then
        return;
    end
    
	BlackoutWorld:Hide();

    local showLevel = false;
    local showRoutes = false;
    local showWayPoints = false;
    
    local min = -1;
    local max = -1;
    
    if (miniWorldMap == "0") then
        -- full screen
        
        CleanUIWorldMapCoords:ClearAllPoints();
        CleanUIWorldMapCoords:SetPoint("BOTTOM", WorldMapFrame, "BOTTOM", 0, 10);
    
        local areaid = GetCurrentMapAreaID();
		local continentID = GetCurrentMapContinent();
        
        if (areaid == 13 or areaid == 14 or areaid == 466 or areaid == 485 or areaid == 862) then
            min = CUI_MAP_RANGE[areaid].min;
            max = CUI_MAP_RANGE[areaid].max;
            
            if (CleanUIData.MAP_SHOWQUESTLEVEL == 1) then
                showLevel = true;
            end
        elseif (areaid == -1 and continentID == 0) then	
            if (CleanUIData.MAP_SHOWSHIPROUTES == 1) then
                showRoutes = true;
            end
        elseif (continentID > 0) then    
            if (CleanUIData.MAP_SHOWWAYPOINTS == 1) then
                showWayPoints = true;
            end
        end
    elseif (miniWorldMap == "1") then
        -- window        
        CleanUIWorldMapCoords:ClearAllPoints();
        CleanUIWorldMapCoords:SetPoint("BOTTOMLEFT", WorldMapPositioningGuide, "BOTTOMLEFT", 16, 10);
    end
    
    -- Level-Informationen
    if (showLevel) then
        CUI_MI_HEADER:Show();
        CUI_MI_ALLIANCE:Show();
        CUI_MI_HORDE:Show();
        CUI_MI_BEST:Show();
        CUI_MI_PVP:Show();
        CUI_MI_DIFFICULT:Show();
    else
        CUI_MI_HEADER:Hide();
        CUI_MI_ALLIANCE:Hide();
        CUI_MI_HORDE:Hide();
        CUI_MI_BEST:Hide();
        CUI_MI_PVP:Hide();
        CUI_MI_DIFFICULT:Hide();
    end

	for ii=0, #(CUI_MAP_INFO), 1 do
        _G["CUI_MI_"..CUI_MAP_INFO[ii].name]:Hide();
            
        if (showLevel and ii >= min and ii<= max) then
            _G["CUI_MI_"..CUI_MAP_INFO[ii].name]:Show();  
        end
    end
    
    -- Schiff-/Zeppelinrouten
    local station, line, sx, sy, ex, ey;
        
    if (showRoutes) then        
        
        local infoframe = _G["CleanUIMapFrame"];
                
        local framewidth = infoframe:GetWidth();
        local frameheight = infoframe:GetHeight();
        
        for index, data in pairs(CUI_MAP_ROUTES) do
            line = _G["CUIRoute"..index];
            if (not line) then
                line = infoframe:CreateTexture("CUIRoute"..index, "ARTWORK");    
                line:SetTexture("Interface\\TaxiFrame\\UI-Taxi-Line");   
            end
            
            sx = framewidth * CUI_MAP_STATIONS[data.start].left / 100;
            sy = frameheight - frameheight * CUI_MAP_STATIONS[data.start].top / 100;
            ex = framewidth * CUI_MAP_STATIONS[data.ende].left / 100;
            ey = frameheight - frameheight * CUI_MAP_STATIONS[data.ende].top / 100;
            
            if (data.faction == "a") then
                line:SetVertexColor(0.0, 0.0, 1.0);
            elseif (data.faction == "h") then
                line:SetVertexColor(1.0, 0.0, 0.0);
            else
                line:SetVertexColor(1.0, 1.0, 0.0);
            end
        
            DrawRouteLine(line, infoframe, sx, sy, ex, ey, 32);
            line:Show();
        end
        
        local x1, x2, y1, y2;
        
        for index, data in pairs(CUI_MAP_STATIONS) do            
            station = _G["CUIStation"..index];
            if (not station) then
                station = infoframe:CreateTexture("CUIStation"..index, "ARTWORK");    
                station:SetTexture("Interface\\Minimap\\OBJECTICONS");   
                station:SetWidth(16);
                station:SetHeight(16);
            end

            if (data.faction == "a") then
                x1, x2, y1, y2 = GetWorldEffectTextureCoords(0);
            elseif (data.faction == "h") then
                x1, x2, y1, y2 = GetWorldEffectTextureCoords(2);
            else
                x1, x2, y1, y2 = GetWorldEffectTextureCoords(3);
            end
            
            station:SetTexCoord(x1, x2, y1, y2);
            
            sx = framewidth * data.left / 100;
            sy = frameheight - frameheight * data.top / 100;
            
            station:SetPoint("CENTER", infoframe, "BOTTOMLEFT", sx, sy);
            station:Show();
        end
    else        
        for index, data in pairs(CUI_MAP_ROUTES) do
            line = _G["CUIRoute"..index];
            if (line) then            
                line:Hide();
            end
        end    
         
        for index, data in pairs(CUI_MAP_STATIONS) do
            station = _G["CUIStation"..index];
            if (station) then            
                station:Hide();
            end
        end
    end
    
    -- Wegpunkte
    if (showWayPoints) then
        CleanUI_ShowWayPoints();
    else
        CleanUI_HideWayPoints();
    end
end

function CleanUI_AddWaypoint(coords)
	local sx, sy, text = strsplit("/ ", coords, 3);
	
	if (sx and sy) then
		local x = tonumber(sx) / 100;
		local y = tonumber(sy) / 100;
	    
	    if (x >= 0 and x <= 1 and y >= 0 and y <= 1) then
		    CleanUI_CreateWaypoint(x, y, text, "Interface\\TAXIFRAME\\UI-Taxi-Icon-Red");    
		    CleanUI_ShowWayPoints();
	    end
    end
end

function CleanUI_ProcessMapClick(adjustedX, adjustedY)
    if (not IsControlKeyDown()) then
        return;
    end
    
    CleanUI_CreateWaypoint(adjustedX, adjustedY);    
    CleanUI_ShowWayPoints();
end

function CleanUI_CreateWaypointAtActPosition()
    SetMapToCurrentZone();
    local posX, posY = GetPlayerMapPosition("player");
    
    CleanUI_CreateWaypoint(posX, posY);
end

function CleanUI_CreateWaypoint(adjustedX, adjustedY, text, icon)   
    local actContinent = GetCurrentMapContinent();
    local actArea = GetCurrentMapAreaID();
    local actLevel = GetCurrentMapDungeonLevel();
    
    local zones = { GetMapZones(actContinent) };
    local zoneIndex = GetCurrentMapZone();
    
    local actZone = zones[zoneIndex];
    
    text = text or date();
    icon = icon or "Interface\\GossipFrame\\GossipGossipIcon";
    
    local x = adjustedX * 100;
    local y = adjustedY * 100;
    
    local waypoint = {continent=actContinent, zone=actZone, area=actArea, level=actLevel, x=adjustedX * 100, y=adjustedY * 100, title=text, icon=icon};
    
    tinsert(CleanUIWayPoints, waypoint);
end

function CleanUI_ShowWayPoints()

    local waypoints = _G["CleanUIMapWayPointFrame"];
    waypoints:Show();
    
    local frameWidth, frameHeight = waypoints:GetSize();

    local actContinent = GetCurrentMapContinent();
    local actArea = GetCurrentMapAreaID();
    local actLevel = GetCurrentMapDungeonLevel();
    
    local zones = { GetMapZones(actContinent) };
    local zoneIndex = GetCurrentMapZone();
    
    local actZone = zones[zoneIndex];
    
    local lastUsedIndex, continent, zone, area, level, x, y, title, icon;
    
    local index = 1;
    local lastUsedIndex = 1;
    for i, data in pairs(CleanUIWayPoints) do
        
        if (data) then
            continent = data.continent;
            zone = data.zone;
            area = data.area;
            level = data.level;
            x = data.x;
            y = data.y;
            title = data.title;
            if (data.icon) then
                icon = data.icon;
            else
                icon = "Interface\\GossipFrame\\GossipGossipIcon";
            end
            
            if (continent == actContinent and zone == actZone and area == actArea and level == actLevel) then
                local waypoint = _G["CleanUIMapWayPoint"..index];
                if (not waypoint) then
                    waypoint = CreateFrame("Button", "CleanUIMapWayPoint"..index, waypoints, "CleanUIMapWayPointTemplate");
                    waypoint:RegisterForClicks("AnyUp");
                    waypoint:SetMovable(true);
                end
                
                waypoint.icon:SetTexture(icon);
                
                waypoint.data = data;      
                
                waypoint.info:SetText(title);
                waypoint.xy:SetText(string.format("%.1f", x).."/"..string.format("%.1f", y));
                
                local px = frameWidth * x / 100;
                local py = frameHeight * y / 100; 
                
                waypoint:Show();
                waypoint:ClearAllPoints();                
                waypoint:SetPoint("CENTER", waypoints, "TOPLEFT", px, -py);
                    
                index = index + 1;
                lastUsedIndex = index;
            end
        end
    end
    
    -- hide unused waypoints
    while (lastUsedIndex) do
        local waypoint = _G["CleanUIMapWayPoint"..lastUsedIndex];
        if (waypoint) then
            waypoint:Hide();
            lastUsedIndex = lastUsedIndex + 1;
        else
            lastUsedIndex = nil;
            break;
        end
    end
end

function CleanUI_WayPoint_OnClick(self, button, down)
    local data = self.data;
    
    if (not data) then
        return;
    end
    
    if (button == "RightButton" and not IsControlKeyDown()) then
        selectedWayPoint = data;
    
        CleanUIMapWayPointContextMenu:ClearAllPoints();
        CleanUIMapWayPointContextMenu:SetPoint("TOPLEFT", self, "TOPLEFT", 10, -15);
        CleanUIMapWayPointContextMenu:Show();
    end
end

function CleanUI_WayPoint_OnMouseDown(frame, button)
    if (button == "RightButton") then
        if (IsControlKeyDown()) then
            frame:StartMoving();
        end
    end
end

function CleanUI_WayPoint_OnMouseUp(frame, button)
    if (button == "RightButton") then
        frame:StopMovingOrSizing();
            
        if (IsControlKeyDown()) then
            data = frame.data;
            local _, _, cursor_x, cursor_y = CleanUI_GetCursorPosition();
            data.x = cursor_x;
            data.y = cursor_y;     
            CleanUI_ShowWayPoints();
        end  
    end
end

function CleanUI_InitWayPointContextMenu(self)    

    UIMenu_Initialize(self);    
    UIMenu_AddButton(self, RENAME_GUILD, nil, function(frame) CleanUI_WayPointContextMenu_Rename() end);
    UIMenu_AddButton(self, EMBLEM_SYMBOL, nil, nil, "CleanUIMapWayPointContextMenuIcons");
    UIMenu_AddButton(self, SEND_LABEL, nil, nil, "CleanUIMapWayPointContextMenuSendTo");
    UIMenu_AddButton(self, DELETE, nil, function(frame) CleanUI_WayPointContextMenu_Delete() end);
    UIMenu_AddButton(self, "");
    UIMenu_AddButton(self, "reset", nil, function(frame) CleanUI_WayPointContextMenu_Reset() end);  
    UIMenu_AddButton(self, "");
    UIMenu_AddButton(self, CANCEL, nil, function(frame) CleanUI_WayPointContextMenu_Cancel() end);    
    UIMenu_AutoSize(self);
    
    self:SetScale(0.7);
end

function CleanUI_InitWayPointContextMenuIcons(self)
    
    UIMenu_Initialize(self);
    UIMenu_AddButton(self, CHAT_DEFAULT, nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\GossipFrame\\GossipGossipIcon") end);
    UIMenu_AddButton(self, "AvailableQuest", nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\GossipFrame\\AvailableQuestIcon") end);
    UIMenu_AddButton(self, "DailyAvailableQuest", nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\GossipFrame\\DailyQuestIcon") end);
    UIMenu_AddButton(self, TUTORIAL_TITLE35, nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\GossipFrame\\TaxiGossipIcon") end);
    UIMenu_AddButton(self, TUTORIAL_TITLE14, nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\GossipFrame\\TrainerGossipIcon") end);
    UIMenu_AddButton(self, TUTORIAL_TITLE20, nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\GossipFrame\\VendorGossipIcon") end);
    UIMenu_AddButton(self, "Taxi gray", nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\TAXIFRAME\\UI-Taxi-Icon-Gray") end);
    UIMenu_AddButton(self, "Taxi green", nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\TAXIFRAME\\UI-Taxi-Icon-Green") end);
    UIMenu_AddButton(self, "Taxi red", nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\TAXIFRAME\\UI-Taxi-Icon-Red") end);
    UIMenu_AddButton(self, "Taxi white", nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\TAXIFRAME\\UI-Taxi-Icon-White") end);
    UIMenu_AddButton(self, "Taxi yellow", nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\TAXIFRAME\\UI-Taxi-Icon-Yellow") end);
    UIMenu_AddButton(self, INVTYPE_BAG, nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\GROUPFRAME\\UI-Group-MasterLooter") end);
    UIMenu_AddButton(self, FACTION_ALLIANCE, nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\WorldStateFrame\\AllianceIcon") end);
    UIMenu_AddButton(self, FACTION_HORDE, nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\WorldStateFrame\\HordeIcon") end);
    UIMenu_AddButton(self, COMBAT, nil, function(frame) CleanUI_WayPointContextMenu_ChangeIcon("Interface\\TUTORIALFRAME\\UI-TutorialFrame-AttackCursor") end);
    UIMenu_AutoSize(self);
    
    self:SetScale(0.7);
end

function CleanUI_InitWayPointContextMenuSendTo(self)
    
    UIMenu_Initialize(self);
    UIMenu_AddButton(self, CHAT_MSG_PARTY, nil, function(frame) CleanUI_WayPointContextMenu_Send(1) end);
    UIMenu_AddButton(self, CHAT_MSG_RAID, nil, function(frame) CleanUI_WayPointContextMenu_Send(2) end);
    UIMenu_AddButton(self, CHAT_MSG_GUILD, nil, function(frame) CleanUI_WayPointContextMenu_Send(3) end);
    UIMenu_AddButton(self, CHAT_MSG_BATTLEGROUND, nil, function(frame) CleanUI_WayPointContextMenu_Send(4) end);
    UIMenu_AddButton(self, CHAT_MSG_WHISPER_INFORM, nil, function(frame) CleanUI_WayPointContextMenu_Send(5) end);
    UIMenu_AutoSize(self);
    
    self:SetScale(0.7);
end

function CleanUI_WayPointContextMenu_ChangeIcon(icon)
    local data = selectedWayPoint;
    
    if (not data) then
        return;
    end

    CleanUIMapWayPointContextMenu:Hide();
    CleanUIMapWayPointContextMenuIcons:Hide();
    
    data.icon = icon;
    CleanUI_ShowWayPoints();
end

function CleanUI_WayPointContextMenu_Rename()  
    local data = selectedWayPoint;
    
    if (not data) then
        return;
    end

    CleanUIMapWayPointContextMenu:Hide();
    CleanUIMapWayPointContextMenuSendTo:Hide();
    
    CleanUIMapWayPointNameEditBox:SetText(data.title);
    
    CleanUIMapWayPointNameEditBox:SetScale(0.7);
    CleanUIMapWayPointNameEditBox:Show();
end

function CleanUI_RenameWayPoint(name)
    local data = selectedWayPoint;
    
    if (not data) then
        return;
    end
    
    data.title = name;
    CleanUI_ShowWayPoints();
end

function CleanUI_WayPointContextMenu_Send(sendto)  

    CleanUIMapWayPointContextMenu:Hide();
    CleanUIMapWayPointContextMenuSendTo:Hide();

    if (sendto == 1) then       -- group
        CleanUI_WayPointContextMenu_SendTo("PARTY");
    elseif (sendto == 2) then   -- raid
        CleanUI_WayPointContextMenu_SendTo("RAID");
    elseif (sendto == 3) then   -- guild
        CleanUI_WayPointContextMenu_SendTo("GUILD");
    elseif (sendto == 4) then   -- battleground
        CleanUI_WayPointContextMenu_SendTo("BATTLEGROUND");
    elseif (sendto == 5) then   -- whisper
        -- ...
    end
end

function CleanUI_WayPointContextMenu_SendTo(channel, name)    
    local data = selectedWayPoint;
    
    if (not data) then
        return;
    end

    local message = data.continent..";"..data.zone..";"..data.area..";"..data.level..";"..data.x..";"..data.y..";"..data.title..";"..data.icon;
    CleanUI_SendWayPoint("CleanUI_WP", message, channel, name);
end

function CleanUI_SendWayPoint(prefix, message, channel, name)  
    if (channel ~= "WHISPER") then
        SendAddonMessage(prefix, message, channel);
    else
        SendAddonMessage(prefix, message, channel, name);
    end  
end

function CleanUI_ReceiveWayPoint(prefix, message, channel, sender)   
    if (prefix == nil) then
        return;
    end  
     
    if (prefix ~= "CleanUI_WP") then
        return;
    end
    
    local playername, _ = UnitName("player");
    
    local rcontinent, rzone, rarea, rlevel, strx, stry, rtitle, ricon = strsplit(";", message, 8);     
    local waypoint = {continent=tonumber(rcontinent), zone=rzone, area=tonumber(rarea), level=tonumber(rlevel), x=tonumber(strx), y=tonumber(stry), title=rtitle, icon=ricon}; 

    if (sender == playername) then
        return;
    end   
    
    CleanUI_AddReceivedWayPoint(waypoint);
    CleanUI_ShowWayPoints();
end

function CleanUI_AddReceivedWayPoint(waypoint)    
    for index, found in pairs(CleanUIWayPoints) do
        if (waypoint.continent == found.continent and
            waypoint.zone == found.zone and
            waypoint.area == found.area and
            waypoint.level == found.level and
            waypoint.x == found.x and
            waypoint.y == found.y and
            waypoint.title == found.title) then
            -- keine doppelten Eintrge
            return;
        end
    end

    tinsert(CleanUIWayPoints, waypoint);
end

function CleanUI_WayPointContextMenu_Delete()

    CleanUIMapWayPointContextMenu:Hide();
    CleanUIMapWayPointContextMenuSendTo:Hide();
    
    for index, found in pairs(CleanUIWayPoints) do    
        if (selectedWayPoint.zone == found.zone and
            selectedWayPoint.x == found.x and
            selectedWayPoint.y == found.y and
            selectedWayPoint.title == found.title) then
            
            table.remove(CleanUIWayPoints, index);
            CleanUI_ShowWayPoints();
            return;
        end
    end
end

function CleanUI_WayPointContextMenu_Reset()
    wipe(CleanUIWayPoints);
    CleanUI_ShowWayPoints();

    CleanUIMapWayPointContextMenu:Hide();
    CleanUIMapWayPointContextMenuSendTo:Hide();
end

function CleanUI_WayPointContextMenu_Cancel()  
    CleanUIMapWayPointContextMenu:Hide();
    CleanUIMapWayPointContextMenuSendTo:Hide();
end

function CleanUI_HideWayPoints()
    local waypoints = _G["CleanUIMapWayPointFrame"];
    waypoints:Hide();
end

function CleanUI_ToggleMapLevel()
    CleanUIConfig_ToggleMapLevel();
    
    local miniWorldMap = GetCVar("miniWorldMap"); 	
 	CleanUI_UpdateMap(miniWorldMap);
end

function CleanUI_ToggleMapRoutes()
    CleanUIConfig_ToggleMapRoutes();
    
    local miniWorldMap = GetCVar("miniWorldMap");   
    CleanUI_UpdateMap(miniWorldMap);
end

function CleanUI_ToggleWayPoints()
    CleanUIConfig_ToggleWayPoints();
    
    local miniWorldMap = GetCVar("miniWorldMap");   
    CleanUI_UpdateMap(miniWorldMap);
end