function CleanUI_InitGossipFrame()    
    CleanUI_GossipFrameHookEvents();
    CleanUI_RegisterGossipFrameEvents();
    
    CleanUI_CleanGossipFrame();
end
    
function CleanUI_RegisterGossipFrameEvents()         
    --local frame = CreateFrame("Frame");
    
    --frame:RegisterEvent("PLAYER_REGEN_DISABLED");  
    
    --frame:HookScript("OnEvent", CleanUI_GossipFrameOnEvent); 
end

function CleanUI_GossipFrameOnEvent(self, event, ...)
    --if (event == "FOO") then
    --end
end

function CleanUI_GossipFrameHookEvents()
    --hooksecurefunc("orig", local);
end

function CleanUI_CleanGossipFrame()
    CleanUI_RemoveTextures(GossipFrame); 
    CleanUI_SetBackdrop(GossipFrame); 
    
    local background = GossipFrame:CreateTexture("CUI_GossipFrameBackground", "BORDER");
    background:ClearAllPoints();
    background:SetPoint("TOPLEFT", GossipFrame, "TOPLEFT", 3, -60);
    background:SetSize(308, 412);
    background:SetTexture("interface\\Addons\\CleanUI\\skins\\frame\\paper-background");
    
    CleanUI_RemoveTextures(GossipFrameInset);
    CleanUI_RemoveTextures(GossipFrameGreetingPanel); 
    
    GossipFramePortrait:Hide();  
        
    CleanUI_ChangeCloseButton(GossipFrame);
    
    CleanUI_CreateHeaderFrame(GossipFrame, "CUI_GossipFrameHeaderBorderframe", 250, GossipFrameNpcNameText);
    GossipFrameTitleText:Hide();
    
    GossipGreetingScrollFrameTop:Hide();
    GossipGreetingScrollFrameMiddle:Hide();
    GossipGreetingScrollFrameBottom:Hide();
    
    CleanUI_ChangeButton(GossipFrameGreetingGoodbyeButton);
    
    GossipTitleButton1:ClearAllPoints();
    GossipTitleButton1:SetPoint("TOPLEFT", GossipGreetingText, "BOTTOMLEFT", 0, -20);
end